//+------------------------------------------------------------------+
//|OpenPivotsbguy                                                    |
//+------------------------------------------------------------------+

#property copyright "sbguy"

extern double  d_lots = 0.1;
extern double  d_firstHoursCautionSMMADistance = 10;
extern double  d_dailyFirstDistanceLimit = 200;
extern double  d_dailySubsequentDistanceLimit = 200;
extern double  d_manualStopLoss = 0;
extern double  d_manualTakeProfit = 0;
extern double  d_trailingStopLoss = 0;
extern double  d_buyStopOnPivotLimit = 50;
extern double  d_buyStopOnOpenPriceLimit = 30;
extern double  d_sellStopOnPivotLimit = 50;
extern double  d_sellStopOnOpenPriceLimit = 30;
extern double  d_buyStopProfitTarget = 50;
extern double  d_sellStopProfitTarget = 50;

extern int     d_slippage = 2;
extern int     i_period  = 2;
extern int     i_dailyEntryTime = 0;
extern int     i_dailyCrossingLimit = 1;
extern int     i_dailyCrossingLimitStartHour = 4;
extern int     i_numberPositions = 4;
extern int     i_entryStopLossStartTime = 8;

extern bool    b_firstHoursCaution = true;
extern bool    b_doNotExitUntilDailyEntryTime = true;
extern bool    b_enterOnlyOnNextCross = true;
extern bool    b_noMoreTrades = false;
extern bool    b_entryStopLoss = true;

extern string  s_stopMethodOne = "1";
extern string  s_stopMethodTwo = "2";
extern string  s_stopMethodThree = "3";
extern string  s_stopMethodFour = "4";
extern string  s_stopMethodFive = "5";

double d_openPivot;
double d_openPivotLast;
double d_2SMMA;
double d_2SMMALast;
double d_myBid;
double d_myAsk;
double d_stopLoss;
double d_buyStopLoss;
double d_sellStopLoss;
double d_buyTakeProfit;
double d_sellTakeProfit;
double d_dailyExtremeHigh;
double d_dailyExtremeLow;

int i_magicOne =     111;
int i_magicTwo =     222;
int i_magicThree =   333;
int i_magicFour =    444;
int i_magicFive =    555;
int i_magicNumber;
int i_totalOrders;
int i_type;
int i;
int j;
int i_commentHolder;
int     i_dailyCrossingLimitCount = 0; 
int     i_dailyCrossingLimitTimeHolder = 25; 

bool b_positionExists = false;
bool b_cautionUpOne = false;
bool b_cautionDownOne = false;
bool b_cautionUpTwo = false;
bool b_cautionDownTwo = false;
bool b_above = false;
bool b_aboveLast = false;
bool b_buyStopsOn = false;
bool b_sellStopsOn = false;
bool b_switchUp = false;
bool b_switchDown = false;
bool b_weBeBuying = false;
bool b_weBeSelling = false;

string s_orderComment;


int start()
{
   bool b_exitBuys = false;
   bool b_exitSells = false;
      
      
   //Housekeeping
   if((TimeHour(TimeCurrent()) > 0) && (TimeHour(TimeCurrent()) < i_dailyCrossingLimitStartHour))
   i_dailyCrossingLimitCount = 0;
   i_dailyCrossingLimitTimeHolder = 25;
   
   if(TimeHour(TimeCurrent()) >= 3)
   b_cautionUpOne = false;
   b_cautionDownOne = false;
   b_cautionUpTwo = false;
   b_cautionDownTwo = false;


   //Setting up Important Variables
   d_myBid = Bid;
   d_myAsk = Ask;
   d_openPivot = iCustom(NULL,PERIOD_H1,"OpenPivotInd_sbg",0,1);
   d_openPivotLast = iCustom(NULL,PERIOD_H1,"OpenPivotInd_sbg",0,2);
   d_2SMMA = iMA(NULL,PERIOD_H1,i_period,0,MODE_SMMA,PRICE_WEIGHTED,1);
   d_2SMMALast = iMA(NULL,PERIOD_H1,i_period,0,MODE_SMMA,PRICE_WEIGHTED,2);
   

   //Setting up the Basic Logic
   if(d_2SMMA > d_openPivot) b_above = true;
   if(d_2SMMALast > d_openPivotLast) b_aboveLast = true;
   if(d_2SMMA < d_openPivot) b_above = false;
   if(d_2SMMALast < d_openPivotLast) b_aboveLast = false;
   
   if((b_above == true) && (b_aboveLast == false))
   {
      b_switchUp = true;
      b_buyStopsOn = false;
   }
   else b_switchUp = false;
   if((b_above == false) && (b_aboveLast == true))
   {
      b_switchDown = true;
      b_sellStopsOn = false;
   }
   else b_switchDown = false;

   
   //The basic idea is look at b_above to buy or sell and 
   //close contradicting positions.
   if(b_above == true)
   {
      b_weBeBuying = true;
      b_weBeSelling = false;
   }

   if(b_above == false)
   {
      b_weBeBuying = false;
      b_weBeSelling = true;
   }
   
     
   //In this section we consider user chosen Options
   //If WeBeBuying and WeBeSelling make it through this
   //minefield there'll be some buying/selling near the bottom
      
   //In the first three hours of the day users may choose not 
   //to switch positions from yesterday's closing
   //position nor close yesterday's hangover positions if certain
   //conditions are met. Conditions are 2SMMA is less than 
   //d_firstHoursCautionSMMADistance from d_OpenPivot and 
   //slope of 2SMMA coincides with yesterday's position. 
   if(b_firstHoursCaution == true)
   {
      if((TimeHour(TimeCurrent())==1)&&(MathAbs(d_2SMMA-d_openPivot) < d_firstHoursCautionSMMADistance*Point))
      {
         if((b_switchUp == true)&&(d_2SMMA < d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
            b_cautionUpOne = true;
         }
         if((b_switchDown == true)&&(d_2SMMA > d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
            b_cautionDownOne = true;
         }
      }
      if((TimeHour(TimeCurrent())==2)&&((b_cautionUpOne||b_cautionDownOne) == true))
      {
         if((b_above == true)&&(d_2SMMA < d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
            b_cautionUpTwo = true;
         }
         if((b_above == false)&&(d_2SMMA > d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
            b_cautionDownTwo = true;
         }
      }
      if((TimeHour(TimeCurrent())==3)&&((b_cautionUpTwo||b_cautionDownTwo) == true))
      {
         if((b_above == true)&&(d_2SMMA < d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
         }
         if((b_above == false)&&(d_2SMMA > d_2SMMALast))
         {
            b_weBeBuying = false;
            b_weBeSelling = false;
         }
      }
   }
      
   //If Users choose to enter later than the first bar of 
   //the bar.(using i_dailyEntryTime) They may also choose not to 
   //close contradicting positions hanging over from previous day.
   //Hence WeBeBuying/WeBeSelling can be set false before 
   //they effect ExitSells/ExitBuys
   if((i_dailyEntryTime > TimeHour(TimeCurrent()))&&(b_doNotExitUntilDailyEntryTime == true))
   {
      b_weBeBuying = false;
      b_weBeSelling = false;
   }
   
   //This section closes down contradicting positions after 
   //a SwitchUp/SwitchDown or anytime subject to 
   //b_doNotExitHangoversUntilDailyEntryTime
   if(b_weBeBuying == true)b_exitSells = true;

   if(b_weBeSelling == true)b_exitBuys = true;
      
   if(b_exitSells == true)
   {
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol())  
         {  
            i_type = OrderType();
            if((i_type == OP_SELL) || (i_type == OP_SELLLIMIT))
            OrderClose(OrderTicket(),OrderLots(),d_myAsk,d_slippage,CLR_NONE);
         }
      }
   }
   
   if(b_exitBuys == true)
   {
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol())  
         {  
            i_type = OrderType();
            if((i_type == OP_BUY) || (i_type == OP_BUYLIMIT))
            OrderClose(OrderTicket(),OrderLots(),d_myBid,d_slippage,CLR_NONE);
         }
      }
   }
   
   
   //Users may choose not to enter until certain time daily 
   if(i_dailyEntryTime > TimeHour(TimeCurrent()))
   {
      b_weBeBuying = false;
      b_weBeSelling = false;
   }

   
   //If Users choose a daily crossing limit further trades are not opened
   //once it is reached. Users may also choose to ignore crossings before 
   //a certain hour
   if(i_dailyCrossingLimit > 0)
   {
      if(((TimeHour(TimeCurrent())) >= (i_dailyCrossingLimitStartHour))&&((b_switchUp || b_switchDown) == true)&&(TimeHour(TimeCurrent()) != i_dailyCrossingLimitTimeHolder))
      {
         i_dailyCrossingLimitCount +=1;
         i_dailyCrossingLimitTimeHolder = TimeHour(TimeCurrent());
      }
      if(i_dailyCrossingLimitCount > i_dailyCrossingLimit)
      {
         b_weBeBuying = false;
         b_weBeSelling = false;
      }
   }
   
   //User can choose not to enter first trade of day if 
   //entry price is too far from the OpenPivot. First trade of day is
   //is determined using i_dailyCrossingLimitCount regardless of time
   if((d_dailyFirstDistanceLimit > 0) && (i_dailyCrossingLimitCount == 0))
   {
      if (MathAbs(d_myBid-d_openPivot) > d_dailyFirstDistanceLimit*Point)
      {
         b_weBeBuying = false;
         b_weBeSelling = false;
         
      }
   }
   
   //User can choose different EntryDistanceLimit for OpenPivot crossing trades
   if((d_dailySubsequentDistanceLimit > 0) && (i_dailyCrossingLimitCount > 0))
   {
      if (MathAbs(d_myBid-d_openPivot) > d_dailySubsequentDistanceLimit*Point)
      {
         b_weBeBuying = false;
         b_weBeSelling = false;
         
      }
   }
   
   //User can choose to wait for a cross to enter positions   
   if(b_enterOnlyOnNextCross == true)
   {
      if((b_switchUp && b_switchDown) == false)
      {
         b_weBeBuying = false;
         b_weBeSelling = false;
      }
   }
   //If true EA will handle current trades but will not open subsequent trades on 
   //subsequent crossings
   if(b_noMoreTrades == true)
   {
      b_weBeBuying = false;
      b_weBeSelling = false;
   }
   
   //The manual stoploss will override b_entryStopLoss 
   if(d_manualStopLoss > 0) 
   {
      d_buyStopLoss = d_myAsk-d_manualStopLoss*Point;
      d_sellStopLoss = d_myBid+d_manualStopLoss*Point;
   }
   else   
   {
      d_buyStopLoss = 0;
      d_sellStopLoss = 0;
   }

   if(d_manualTakeProfit > 0)
   {
      d_buyTakeProfit = d_myAsk+d_manualTakeProfit*Point;
      d_sellTakeProfit = d_myBid-d_manualTakeProfit*Point;
   }
   else
   {
      d_buyTakeProfit = 0;
      d_sellTakeProfit = 0;
   
   }

   if(b_buyStopsOn == true)
   b_weBeBuying = false;
   
   if(b_sellStopsOn == true)
   b_weBeSelling = false;
   

   if(b_weBeBuying == true)
   {
      for(i=1;i<=i_numberPositions;i++)
      {
         if(i==1)
         {
            i_magicNumber = i_magicOne;    
            s_orderComment = s_stopMethodOne;
         }
         if(i==2)
         {
            i_magicNumber = i_magicTwo;
            s_orderComment = s_stopMethodTwo;
         }
         if(i==3)
         {
            i_magicNumber = i_magicThree;  
            s_orderComment = s_stopMethodThree;
         }
         if(i==4)
         {
            i_magicNumber = i_magicFour;
            s_orderComment = s_stopMethodFour;
         }
         if(i==5)
         {
            i_magicNumber = i_magicFive;
            s_orderComment = s_stopMethodFive;
         }   
         
         b_positionExists = false;
         i_totalOrders = OrdersTotal();
         for(j=0;j<i_totalOrders;j++)         
         {
            OrderSelect(j,SELECT_BY_POS);
            if((OrderSymbol() == Symbol()) && (OrderMagicNumber() == i_magicNumber)) 
            {  
               i_type = OrderType();
               if((i_type == OP_BUY) || (i_type == OP_BUYLIMIT))
               b_positionExists = true;
            }
         }
         if(b_positionExists == false)
         OrderSend(Symbol(),OP_BUYLIMIT,d_lots,d_myAsk,d_slippage,d_buyStopLoss,d_buyTakeProfit,s_orderComment,i_magicNumber,0,CLR_NONE);
      }
   }
   
   if(b_weBeSelling == true)
   {
      for(i=1;i<=i_numberPositions;i++)
      {
         switch(i)
         {
            case 1: i_magicNumber = i_magicOne;    s_orderComment = s_stopMethodOne;break;
            case 2: i_magicNumber = i_magicTwo;    s_orderComment = s_stopMethodTwo;break;
            case 3: i_magicNumber = i_magicThree;  s_orderComment = s_stopMethodThree;break;
            case 4: i_magicNumber = i_magicFour;   s_orderComment = s_stopMethodFour;break;
            case 5: i_magicNumber = i_magicFive;   s_orderComment = s_stopMethodFive;break;
         }   
         
         b_positionExists = false;
         i_totalOrders = OrdersTotal();
         for(j=0;j<i_totalOrders;j++)         
         {
            OrderSelect(j,SELECT_BY_POS);
            if((OrderSymbol() == Symbol()) && (OrderMagicNumber() == i_magicNumber)) 
            {  
               i_type = OrderType();
               if((i_type == OP_SELL) || (i_type == OP_SELLLIMIT))
               b_positionExists = true;
            }
         }
         if(b_positionExists == false)
         OrderSend(Symbol(),OP_SELLLIMIT,d_lots,d_myBid,d_slippage,d_sellStopLoss,d_sellTakeProfit,s_orderComment,i_magicNumber,0,CLR_NONE);
      }
   }
       
   if(d_trailingStopLoss > 0)
   {
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_BUY)
            {
               d_stopLoss = OrderStopLoss();
               if((d_stopLoss == 0) ||((MathAbs(d_myBid-d_stopLoss)) > d_trailingStopLoss*Point))
               OrderModify(OrderTicket(), OrderOpenPrice(),d_myBid-d_trailingStopLoss*Point, OrderTakeProfit(),0,CLR_NONE);
            }
            if(i_type == OP_SELL)
            {
               d_stopLoss = OrderStopLoss();
               if((d_stopLoss == 0) ||((MathAbs(d_myAsk-d_stopLoss)) > d_trailingStopLoss*Point))
               OrderModify(OrderTicket(), OrderOpenPrice(),d_myAsk+d_trailingStopLoss*Point, OrderTakeProfit(),0,CLR_NONE);
            }
         }
      }
   }
   
   //Managing open positions with a variety of stops
   if(b_above == true)
   {
      if((d_myBid-d_openPivot) > (d_buyStopOnPivotLimit*Point))
      b_buyStopsOn = true;
      
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_BUY)
            {
               if((d_myAsk-OrderOpenPrice()) > (d_buyStopOnOpenPriceLimit*Point))
               b_buyStopsOn = true;
            }
         }
      }
      if(b_aboveLast == true)
      {
         if((iHigh(NULL,PERIOD_H1,1)>iHigh(NULL,PERIOD_H1,2)) && (iHigh(NULL,PERIOD_H1,2)>iHigh(NULL,PERIOD_H1,3)) && (iLow(NULL,PERIOD_H1,1)>iLow(NULL,PERIOD_H1,2)) && (iLow(NULL,PERIOD_H1,2)>iLow(NULL,PERIOD_H1,3)))
         b_buyStopsOn = true;
      }
   }               
   
   if(b_above == false)
   {
      if((d_openPivot-d_myBid) > (d_sellStopOnPivotLimit*Point))
      b_sellStopsOn = true;
      
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_SELL)
            {
               if((OrderOpenPrice()-d_myBid) > (d_sellStopOnOpenPriceLimit*Point))
               b_sellStopsOn = true;
            }
         }
      }
      if(b_aboveLast == false)
      {
         if((iHigh(NULL,PERIOD_H1,1)<iHigh(NULL,PERIOD_H1,2)) && (iHigh(NULL,PERIOD_H1,2)<iHigh(NULL,PERIOD_H1,3)) && (iLow(NULL,PERIOD_H1,1)<iLow(NULL,PERIOD_H1,2)) && (iLow(NULL,PERIOD_H1,2)<iLow(NULL,PERIOD_H1,3)))
         b_sellStopsOn = true;
      }
   }

   if(b_buyStopsOn == true)
   {
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_BUY)
            {
               i_commentHolder = StrToInteger(OrderComment());
               switch(i_commentHolder)
               {
                  case 1:
                  if((d_myBid-OrderOpenPrice()) > (d_buyStopProfitTarget*Point))
                  OrderClose(OrderTicket(),OrderLots(),d_myBid,d_slippage,CLR_NONE);break;
                  case 2:
                  if(d_myBid < iLow(NULL,PERIOD_H1,1))
                  OrderClose(OrderTicket(),OrderLots(),d_myBid,d_slippage,CLR_NONE);break;
                  case 3:
                  if((d_myBid < iLow(NULL,PERIOD_H1,1))&&(d_myBid < iLow(NULL,PERIOD_H1,2))&&(d_myBid < iLow(NULL,PERIOD_H1,3))&&(d_myBid < iLow(NULL,PERIOD_H1,4)))
                  OrderClose(OrderTicket(),OrderLots(),d_myBid,d_slippage,CLR_NONE);break;
                  case 4:
                  break;
                  case 5:
                  break;
               }
            }
         }
      }
   }
   if(b_sellStopsOn == true)
   {
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_SELL)
            {
               i_commentHolder = StrToInteger(OrderComment());
               switch(i_commentHolder)
               {
                  case 1:
                  if((OrderOpenPrice()-d_myAsk) > (d_sellStopProfitTarget*Point))
                  OrderClose(OrderTicket(),OrderLots(),d_myAsk,d_slippage,CLR_NONE);break;
                  case 2:
                  if(d_myBid > iHigh(NULL,PERIOD_H1,1))
                  OrderClose(OrderTicket(),OrderLots(),d_myAsk,d_slippage,CLR_NONE);break;
                  case 3:
                  if((d_myBid > iHigh(NULL,PERIOD_H1,1))&&(d_myBid > iHigh(NULL,PERIOD_H1,2))&&(d_myBid > iHigh(NULL,PERIOD_H1,3))&&(d_myBid > iHigh(NULL,PERIOD_H1,4)))
                  OrderClose(OrderTicket(),OrderLots(),d_myAsk,d_slippage,CLR_NONE);break;
                  case 4:
                  break;
                  case 5:
                  break;
               }
            }
         }
      }
   }
   
   if((b_entryStopLoss == true)&&((TimeHour(TimeCurrent())) >= (i_entryStopLossStartTime)))
   {
      for(i=1;i<=TimeHour(TimeCurrent());i++)
      {
         if(i==1)
         {
            d_dailyExtremeHigh = iHigh(NULL,PERIOD_H1,i);
            d_dailyExtremeLow = iLow(NULL,PERIOD_H1,i);
         }
         if(i>1)
         {
            if(iHigh(NULL,PERIOD_H1,i) > d_dailyExtremeHigh)
            d_dailyExtremeHigh = iHigh(NULL,PERIOD_H1,i);
         
            if(iLow(NULL,PERIOD_H1,i) < d_dailyExtremeLow)
            d_dailyExtremeLow = iLow(NULL,PERIOD_H1,i);
         }
      }
         
      
      i_totalOrders = OrdersTotal();
      for(i=0;i<i_totalOrders;i++)         
      {
         OrderSelect(i,SELECT_BY_POS);
         if(OrderSymbol() == Symbol()) 
         {  
            i_type = OrderType();
            if(i_type == OP_BUY)
            {
               if(d_myBid < d_dailyExtremeLow)
               {
                  b_buyStopsOn = true;
                  OrderClose(OrderTicket(),OrderLots(),d_myBid,d_slippage,CLR_NONE);
               }
            }
            if(i_type == OP_SELL)
            {
               if(d_myBid > d_dailyExtremeHigh)
               {
                  b_sellStopsOn = true;
                  OrderClose(OrderTicket(),OrderLots(),d_myAsk,d_slippage,CLR_NONE);
               }
            }
         }
      }
   }
return(0);
}